#include "Riostream.h"
#include "TDatime.h"
#include "TPolyMarker.h"
#include "TPolyLine.h"
#include "TLine.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TAxis.h"
#include "TH1.h"
#include "TH2.h"
#include "TLegend.h"  
#include "TFile.h"
#include "TTree.h"
#include "TStyle.h"
#include "TChain.h"
#include "TMarker.h"
#include "TROOT.h"
#include "TF1.h"
#include "TProfile.h"
#include "TStyle.h"

void HallA_style() {
  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(1111);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(505);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.1);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.3);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.045,"X");
  gStyle->SetTitleOffset(1.3,"X");
  gStyle->SetLabelSize(0.045,"Y");
  gStyle->SetTitleOffset(1.3,"Y");
  gStyle->SetNdivisions(505,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);
  gStyle->SetEndErrorSize(7);
}


double DoResults(int MAXnum)
{




double ESlopeAnihilation[24][5] = {	
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
//{0.0, -325.957, 7046.55,  -6757.74, -8188.29}, //7
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0}
};

double dESlopeAnihilation[24][5] = {	
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, -151.31, 1654.26, -345.516, 15143.7}, //#7
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0},
{0.0, 0.0, 0.0, 0.0, 0.0}
};

  Double_t xC[9] = {500.0, 852.0, 1200.0, 1500.0, 2100.0, 1356.0, 1000.0, 762.0, 0.0};
  Double_t yC[9] = {1750.0, 1350.0, 1130.0, 970.0, 770.0, 625.0, 500.0, 400.0, 0.0};
  TPolyLine *pline1 = new TPolyLine(9,xC,yC);
  pline1->SetFillColor(38);
  pline1->SetLineColor(2);
  pline1->SetLineWidth(2);

  TF1 *funPoly4 = new TF1("funPoly4","350.0*(1.0 + 150.0*pow(x,4))",-0.25,0.24);
  funPoly4->SetLineColor(2);
  funPoly4->SetLineWidth(2);


  
  Double_t BB_tp_e_LE[24];
  Double_t BB_tp_e_RE[24];  
  Int_t Ndata_BB_tp_e_LE;
  Int_t Ndata_BB_tp_e_RE;  
  Double_t BB_tp_de_LE[24];
  Double_t BB_tp_de_RE[24];  
  Int_t Ndata_BB_tp_de_LE;
  Int_t Ndata_BB_tp_de_RE;  
  Double_t BB_tp_trx[100];
  Double_t BB_tp_try[100];
  Double_t BB_tp_trHitIndex[100];
  Double_t BB_tp_e_hit_bar[100];
  Double_t BB_tp_de_hit_bar[100];
  Double_t BB_tr_ph[100];
  Double_t DL_t3[100];


  TChain *t1 =new TChain("tout");
  
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_3488.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_1518.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_3151.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_2164.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_2413.root");
  t1->Add("./ROOTResults/eed_Test_GoodEvents_3270.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_3271.root");
  //t1->Add("./ROOTResults/eed_Test_GoodEvents_3272.root");

  assert(t1);  

  t1->SetBranchAddress( "BB.tp.e.LE", &BB_tp_e_LE);
  t1->SetBranchAddress( "BB.tp.e.RE", &BB_tp_e_RE);
  t1->SetBranchAddress( "Ndata.BB.tp.e.LE", &Ndata_BB_tp_e_LE);
  t1->SetBranchAddress( "Ndata.BB.tp.e.RE", &Ndata_BB_tp_e_RE);
  t1->SetBranchAddress( "BB.tp.de.LE", &BB_tp_de_LE);
  t1->SetBranchAddress( "BB.tp.de.RE", &BB_tp_de_RE);
  t1->SetBranchAddress( "Ndata.BB.tp.de.LE", &Ndata_BB_tp_de_LE);
  t1->SetBranchAddress( "Ndata.BB.tp.de.RE", &Ndata_BB_tp_de_RE);
  t1->SetBranchAddress( "BB.tp.trx", &BB_tp_trx);
  t1->SetBranchAddress( "BB.tp.try", &BB_tp_try); 
  t1->SetBranchAddress( "BB.tp.e.hit_bar", &BB_tp_e_hit_bar);
  t1->SetBranchAddress( "BB.tp.de.hit_bar", &BB_tp_de_hit_bar);
  t1->SetBranchAddress( "BB.tp.trHitIndex", &BB_tp_trHitIndex);
  t1->SetBranchAddress( "BB.tr.ph", &BB_tr_ph);
  t1->SetBranchAddress( "DL.t3", &DL_t3);  


 

  int num = t1->GetEntries();
  cout<<"Number of entries : "<<num<<endl;
  double number = MAXnum;
  if (MAXnum<0) number = num;

  TString name;
  name.Form("hEplaneGain");   
  TH2F *hEplaneGain = new TH2F(name.Data(), name.Data(), 24,0,24,200,0,4000);
  name.Form("hdEplaneGain");   
  TH2F *hdEplaneGain = new TH2F(name.Data(), name.Data(), 24,0,24,200,0,4000);
  name.Form("hEdEHitPlane");   
  TH2F *hEdEHitPlane = new TH2F(name.Data(), name.Data(), 24,0,24,24,0,24);

  
  
  TH2F *hADCEdEPaddle[24];
  TH2F *hADCEdEp1Paddle[24];
  TH1F *hADCEPaddle[24];
  TH1F *hADCdEPaddle[24];
  TH2F *hADCEvsFpYPaddle[24];
  TH2F *hADCdEvsFpYPaddle[24];
 
  TH2F *hADCE_DLt3_Paddle[24];
  TH2F *hADCdE_DLt3_Paddle[24];
  TH1F *hDLt3_Paddle[24];
 

  for (int i = 0; i<24; i++){
    name.Form("hADCEdEPaddle%d",i);   
    hADCEdEPaddle[i] = new TH2F(name.Data(), name.Data(), 500,0,3500,500,0,2500);
    name.Form("hADCEdEp1Paddle%d",i);   
    hADCEdEp1Paddle[i] = new TH2F(name.Data(), name.Data(), 500,0,3500,500,0,2500);
    name.Form("ADCEPaddle%d",i);   
    hADCEPaddle[i] = new TH1F(name.Data(), name.Data(), 500,0,3500);
    name.Form("hADCdEPaddle%d",i);   
    hADCdEPaddle[i] = new TH1F(name.Data(), name.Data(), 120,0,1000);

    name.Form("hADCEvsFpYPaddle%d",i);   
    hADCEvsFpYPaddle[i] = new TH2F(name.Data(), name.Data(), 500,-0.3,0.3,500,0,3500);
    name.Form("hADCdEvsFpYPaddle%d",i);   
    hADCdEvsFpYPaddle[i] = new TH2F(name.Data(), name.Data(), 500,-0.3,0.3,500,0,2500);

   
    name.Form("hADCE_DLt3_Paddle%d",i);   
    hADCE_DLt3_Paddle[i] = new TH2F(name.Data(), name.Data(), 300,700,1000,500,0,3500);

    name.Form("hADCdE_DLt3_Paddle%d",i);   
    hADCdE_DLt3_Paddle[i] = new TH2F(name.Data(), name.Data(), 300,700,1000,500,0,3500);


    name.Form("hDLt3_Paddle%d",i);   
    hDLt3_Paddle[i] = new TH1F(name.Data(), name.Data(), 300,700,1000);


  }

  for (int i = 0; i<number; i++){
    t1->GetEntry(i);
    if ((i%1000==0) && i>0) cout<<i<<"  equals to: "<<i/number*100.0<<"%"<<endl; 

    // if (fabs(BB_tp_try[0])>0.01) continue;

    // which hit in TP is consistent with the track in MWDC? I can choose index [0], because I consider only those
    // events with one track in chambers.
    int trHitIndex = (int) BB_tp_trHitIndex[0];
    // first we check which plane was hit. 
    int EplaneHit = (int)BB_tp_e_hit_bar[trHitIndex];
    int dEplaneHit = (int)BB_tp_de_hit_bar[trHitIndex];
    // to be able to calibrate bars, I need to know which bar exactly I am dealing with.
    if ((EplaneHit!=dEplaneHit-1) && (EplaneHit!=dEplaneHit)) continue; 
    hEdEHitPlane->Fill(EplaneHit, dEplaneHit);

    double EmeanADCValue = sqrt(BB_tp_e_RE[EplaneHit]*BB_tp_e_LE[EplaneHit])- pow(BB_tp_try[0],0)*ESlopeAnihilation[EplaneHit][0] - pow(BB_tp_try[0],1)*ESlopeAnihilation[EplaneHit][1] - pow(BB_tp_try[0],2)*ESlopeAnihilation[EplaneHit][2] - pow(BB_tp_try[0],3)*ESlopeAnihilation[EplaneHit][3] - pow(BB_tp_try[0],4)*ESlopeAnihilation[EplaneHit][4] ;
   
    double dEmeanADCValue = 2.0*(sqrt(BB_tp_de_RE[dEplaneHit]*BB_tp_de_LE[dEplaneHit]) - pow(BB_tp_try[0],0)*dESlopeAnihilation[dEplaneHit][0] - pow(BB_tp_try[0],1)*dESlopeAnihilation[dEplaneHit][1] - pow(BB_tp_try[0],2)*dESlopeAnihilation[dEplaneHit][2] - pow(BB_tp_try[0],3)*dESlopeAnihilation[dEplaneHit][3] - pow(BB_tp_try[0],4)*dESlopeAnihilation[dEplaneHit][4]) ;


    hADCE_DLt3_Paddle[EplaneHit]->Fill(DL_t3[0], EmeanADCValue);
    hADCdE_DLt3_Paddle[dEplaneHit]->Fill(DL_t3[0], dEmeanADCValue);
    hDLt3_Paddle[EplaneHit]->Fill(DL_t3[0]);

    
    hEplaneGain->Fill(1.0*EplaneHit, EmeanADCValue);
    hdEplaneGain->Fill(1.0*dEplaneHit, dEmeanADCValue);
       

    hADCEvsFpYPaddle[EplaneHit]->Fill(BB_tp_try[0], EmeanADCValue ); 
    hADCdEvsFpYPaddle[dEplaneHit]->Fill(BB_tp_try[0], dEmeanADCValue);
       
    if ((EplaneHit==dEplaneHit-1)) hADCEdEp1Paddle[EplaneHit]->Fill(EmeanADCValue,dEmeanADCValue);
    if ((EplaneHit==dEplaneHit)) hADCEdEPaddle[EplaneHit]->Fill(EmeanADCValue,dEmeanADCValue);


    hADCEPaddle[EplaneHit]->Fill(EmeanADCValue);
    if (fabs(EmeanADCValue-1000.0)<30.0) hADCdEPaddle[dEplaneHit]->Fill(dEmeanADCValue);     

  }


  name.Form("C0");
  TCanvas *c0 = new TCanvas(name.Data(),name.Data(),1170,660);
  c0->Divide(1,1,0.001,0.001);
  c0->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);
  //gPad->SetLogz();
  hEdEHitPlane->Draw("colz");

  name.Form("figure_EdE_hitPaddle.png");
  c0->Print(name.Data());


  name.Form("C1");
  TCanvas *c1 = new TCanvas(name.Data(),name.Data(),1170,660);
  c1->Divide(1,1,0.001,0.001);
  c1->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);
  //gPad->SetLogz();
  hEplaneGain->Draw("colz");

  name.Form("figure_Eplane_Gain.png");
  c1->Print(name.Data());


  name.Form("C2");
  TCanvas *c2 = new TCanvas(name.Data(),name.Data(),1170,660);
  c2->Divide(1,1,0.001,0.001);
  c2->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);
  //gPad->SetLogz();
  hdEplaneGain->Draw("colz");

  name.Form("figure_dEplane_Gain.png");
  c2->Print(name.Data());


  int PaddleNum = 7;


  TH2F *hADCEdEPaddleSum = new TH2F("hADCEdEPaddleSum", "hADCEdEPaddleSum", 500,0,3000,500,0,2500);
  TCanvas *c3[24];
  //for (int i =4; i<13+1; i++){ 
  for (int i =PaddleNum; i<PaddleNum+1; i++){ 
    name.Form("C3_%d",i);
    c3[i] = new TCanvas(name.Data(),name.Data(),1170,660);
    c3[i]->Divide(2,1,0.001,0.001);
    c3[i]->cd(1);
    gPad->SetGrid();
    gStyle->SetPalette(1);
    hADCEdEPaddle[i]->Draw("colz");
    pline1->Draw("same");
    c3[i]->cd(2);
    gPad->SetGrid();
    gStyle->SetPalette(1);
    hADCEdEp1Paddle[i]->Draw("colz");
    pline1->Draw("same");

    name.Form("figure_EdE_paddle%d.png",i);
    c3[i]->Print(name.Data());


    hADCEdEPaddleSum->Add(hADCEdEPaddle[i],1);
    hADCEdEPaddleSum->Add(hADCEdEp1Paddle[i],1);
  }


  TCanvas *c3a = new TCanvas("c3a","c3a",660,660);
  c3a->Divide(1,1,0.001,0.001);
  c3a->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);
  hADCEdEPaddleSum->Draw("colz");

  name.Form("figure_EdE_sum_plot.png");
  c3a->Print(name.Data());



  TCanvas *c4[24];
  TLine *UpperLimitLine[24];
  TF1 *fitfun[24];
  for (int i = PaddleNum; i<PaddleNum+1; i++){
  //for (int i = 4; i<15+1; i++){  
    name.Form("C4_%d",i);
    c4[i] = new TCanvas(name.Data(),name.Data(),1170,660);
    c4[i]->Divide(2,1,0.001,0.001);
    c4[i]->cd(1);
    gPad->SetGrid();
    gPad->SetLogy();
    hADCEPaddle[i]->Draw();
    UpperLimitLine[i] = new TLine(2200, 0.0, 2200, 10000);
    UpperLimitLine[i]->SetLineColor(kRed);
    UpperLimitLine[i]->SetLineWidth(1.5);
    UpperLimitLine[i]->Draw("same");

    c4[i]->cd(2);
    gPad->SetGrid();
    //gPad->SetLogy();
    hADCdEPaddle[i]->Draw();
    name.Form("fitfun_%d",i);  
    fitfun[i] = new TF1(name.Data(), "gaus", 0, 10000);
    hADCdEPaddle[i]->Fit(name.Data(), "RWV");
    fitfun[i]->SetLineColor(kBlue);

    name.Form("figure_EdE_calibration_paddle%d.png",i);
    c4[i]->Print(name.Data());
  }
 
  TCanvas *c5[24];

  for (int i = PaddleNum; i<PaddleNum+1; i++){
  //for (int i = 4; i<13+1; i++){  
    name.Form("C5_%d",i);
    c5[i] = new TCanvas(name.Data(),name.Data(),1170,660);
    c5[i]->Divide(1,2,0.001,0.001);
    c5[i]->cd(1);
    gPad->SetGrid();
    //gPad->SetLogy();
    gStyle->SetPalette(1);
    hADCEvsFpYPaddle[i]->Draw("colz");
    c5[i]->cd(2);
    gPad->SetGrid();
    //gPad->SetLogy();
    gStyle->SetPalette(1);
    hADCdEvsFpYPaddle[i]->Draw("colz");
 
    //funPoly4->Draw("same");  

    name.Form("figure_EdE_vs_FpY_paddle%d.png",i);
    c5[i]->Print(name.Data());

  }


  TCanvas *c6[24];
  TH2F *hADCE_DLt3_PaddleSum = new TH2F("hADCE_DLt3_PaddleSum", "hADCE_DLt3_PaddleSum", 300,700,1000,500,0,3500);
  for (int i = PaddleNum; i<PaddleNum+1; i++){
  //for (int i = 4; i<13+1; i++){  
    name.Form("C6_%d",i);
    c6[i] = new TCanvas(name.Data(),name.Data(),1170,660);
    c6[i]->Divide(1,2,0.001,0.001);
    c6[i]->cd(1);
    gPad->SetGrid();
    //gPad->SetLogy();
    gStyle->SetPalette(1);
    hADCE_DLt3_Paddle[i]->Draw("colz");

    c6[i]->cd(2);
    gPad->SetGrid();
    gPad->SetLogy();
    hDLt3_Paddle[i]->Draw("");

    hADCE_DLt3_PaddleSum->Add( hADCE_DLt3_Paddle[i],1);

    name.Form("figure_E_vs_DLt3_paddle%d.png",i);
    c6[i]->Print(name.Data());

  }

  TCanvas *c6a = new TCanvas("c6a","c6a",660,660);
  c6a->Divide(1,1,0.001,0.001);
  c6a->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);  
  gPad->SetLogz();
  hADCE_DLt3_PaddleSum->Draw("colz");

  name.Form("figure_Et3_sum_plot.png");
  c6a->Print(name.Data());

  TCanvas *c7[24];
  TH2F *hADCdE_DLt3_PaddleSum = new TH2F("hADCdE_DLt3_PaddleSum", "hADCdE_DLt3_PaddleSum", 300,700,1000,500,0,3500);
  for (int i = PaddleNum; i<PaddleNum+1; i++){
  //for (int i = 4; i<13+1; i++){  
    name.Form("C7_%d",i);
    c7[i] = new TCanvas(name.Data(),name.Data(),1170,660);
    c7[i]->Divide(1,2,0.001,0.001);
    c7[i]->cd(1);
    gPad->SetGrid();
    //gPad->SetLogy();
    gStyle->SetPalette(1);
    hADCdE_DLt3_Paddle[i]->Draw("colz");

    c7[i]->cd(2);
    gPad->SetGrid();
    gPad->SetLogy();
    hDLt3_Paddle[i]->Draw("");

    hADCdE_DLt3_PaddleSum->Add( hADCdE_DLt3_Paddle[i],1);

    name.Form("figure_dE_vs_DLt3_paddle%d.png",i);
    c7[i]->Print(name.Data());

  }

  TCanvas *c7a = new TCanvas("c7a","c7a",660,660);
  c7a->Divide(1,1,0.001,0.001);
  c7a->cd(1);
  gPad->SetGrid();
  gStyle->SetPalette(1);  
  gPad->SetLogz();
  hADCdE_DLt3_PaddleSum->Draw("colz");

  name.Form("figure_dEt3_sum_plot.png");
  c7a->Print(name.Data());


 

}



void EdECalibrationGeom2()
{
 HallA_style();
 DoResults(-1);

}

