#include "Riostream.h"
#include "TDatime.h"
#include "TPolyMarker.h"
#include "TPolyLine.h"
#include "TLine.h"
#include "TCanvas.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TAxis.h"
#include "TH1.h"
#include "TH2.h"
#include "TLegend.h"  
#include "TFile.h"
#include "TTree.h"
#include "TStyle.h"
#include "TChain.h"
#include "TMarker.h"
#include "TROOT.h"
#include "TF1.h"
#include "TProfile.h"
#include "TStyle.h"

void HallA_style() {
  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(1111);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(505);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.1);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.3);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.045,"X");
  gStyle->SetTitleOffset(1.3,"X");
  gStyle->SetLabelSize(0.045,"Y");
  gStyle->SetTitleOffset(1.3,"Y");
  gStyle->SetNdivisions(505,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);
  gStyle->SetEndErrorSize(7);
}



void racunaj()
{

  const double BeamEnergy = 2425.48;

  const int MAX_RANGE = 500;
  const int MIN_RANGE = 100;
  const int TDC_MIN_RANGE = -1100;
  const int TDC_MAX_RANGE = -1000;
  
  const int CANVAS_SIZE_X = 1220;
  const int CANVAS_SIZE_Y = 900;

  //TString Image_Ext = ".png";
  //TString Image_Ext = ".pdf";
  
  cout << "Hello..."<< endl;
  cout<< "Enter the run number: "<<endl;
  int runnumber;
  cin>>runnumber;
  


  TChain *t1 =new TChain("T");
  /*

  TString filename="/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_";
  filename+=runnumber;
  filename+=".root";
  
  TString filename2="/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_";
  filename2+=runnumber;
  filename2+="_1.root";
  */
  
  //t1->Add(filename.Data());
  //t1->Add(filename2.Data());
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2274.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2275.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2276.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2277.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2278.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2279.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2280.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2281.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2282.root");
 
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2283.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2284.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2285.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2286.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2287.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2288.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2289.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2290.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2291.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2292.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2293.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2294.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2295.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2296.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2297.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2298.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2299.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2300.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2301.root");
  
  
  /*
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2285.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2285_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2286.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2286_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2287.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2287_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2288.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2288_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2289.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2289_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2290.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2290_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2291.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2291_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2292.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2292_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2293.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2293_1.root");  
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2294.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2294_1.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2295.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2295_1.root");  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2296.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2296_1.root");  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2297.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2297_1.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2298.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2298_1.root");  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2299.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2299_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2300.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2300_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2301.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2301_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2303.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2303_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2304.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2304_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2305.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2305_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2306.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2306_1.root");

  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2307.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2307_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2308.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2308_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2309.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2309_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2310.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2310_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2311.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2311_1.root");
  
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2314.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2314_1.root");
  
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2315.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2315_1.root");
*/
  /*
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2841.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2842.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2843.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2844.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2845.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2846.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2847.root");
  t1->Add("/adaql10/work1/e05102/miha_ROOTfiles/e05102_L_T5only_2848.root");
  */
  
  assert(t1);
  // sedaj prestejmo koliko entrijev ima dani run
  int num =  t1->GetEntries();
  cout<<"Number of events is : "<<num<<endl;
  
  Double_t BB_tp_e_LA[24];  
  Double_t BB_tp_e_RA[24];
  
  Double_t BB_tp_de_LA[24];  
  Double_t BB_tp_de_RA[24];
  
  Double_t BB_tp_e_LT[24];  
  Double_t BB_tp_e_RT[24];
  
  Double_t BB_tp_de_LT[24];  
  Double_t BB_tp_de_RT[24];

  Double_t L_gold_p;
  
  Int_t Ndata_DL_edtmbb;

  Double_t g0hel_L_helicity;

  Double_t VertexTime_tr_momentum[100];  
  Double_t VertexTime_tr_n;
  
  Double_t DL_t3[1000];
  Int_t    Ndata_DL_t3;
  
  Double_t DL_t1[1000];
  Int_t    Ndata_DL_t1;
  
    
  Double_t evtype;  
  Double_t evtypebits;
 
  t1->SetBranchAddress( "BB.tp.e.LA", &BB_tp_e_LA);
  t1->SetBranchAddress( "BB.tp.e.RA", &BB_tp_e_RA);
  
  t1->SetBranchAddress( "BB.tp.de.LA", &BB_tp_de_LA);
  t1->SetBranchAddress( "BB.tp.de.RA", &BB_tp_de_RA);
  
 
  t1->SetBranchAddress( "BB.tp.e.LT", &BB_tp_e_LT);
  t1->SetBranchAddress( "BB.tp.e.RT", &BB_tp_e_RT);
  
  t1->SetBranchAddress( "BB.tp.de.LT", &BB_tp_de_LT);
  t1->SetBranchAddress( "BB.tp.de.RT", &BB_tp_de_RT);
  
  t1->SetBranchAddress( "Ndata.DL.edtmbb", &Ndata_DL_edtmbb);
   
  t1->SetBranchAddress( "Ndata.DL.t3", &Ndata_DL_t3);
  t1->SetBranchAddress( "DL.t3", &DL_t3);

  t1->SetBranchAddress( "L.gold.p", &L_gold_p);

  t1->SetBranchAddress( "g0hel.L.helicity", &g0hel_L_helicity);

  t1->SetBranchAddress( "VertexTime.tr.momentum", &VertexTime_tr_momentum);
  t1->SetBranchAddress( "VertexTime.tr.n", &VertexTime_tr_n);
  
  t1->SetBranchAddress( "Ndata.DL.t1", &Ndata_DL_t1);
  t1->SetBranchAddress( "DL.t1", &DL_t1);


  
 
// lets define histograms  

  TH1F *hTDCDiff_EPaddle[24];   
  TH1F *hTDCDiffMean_EPaddle[24]; 

  
  TH2F *hEdECut_Paddle[24]; 

  TH2F *hEdECut_PaddleSum = new TH2F("hEdECut_PaddleSum","Paddle Sum [4-17]",200,500,3000,200,300,2000);   

  TH2F *hEdECut_PaddleSumProton = new TH2F("hEdECut_PaddleSumProtons","Paddle Sum [4-17] Protons",200,500,3000,200,300,2000);  

  TH2F *hPDeuteron_PElectron = new TH2F("hPDeuteron_PElectron","hPDeuteron_PElectron",500,2.2,2.4,500,200,1000); 
 
  TH2F *hEdEDeuterons_Reg1 = new TH2F("hEdEDeuterons_Reg1","Deuterons 1st Reg",200,500,3000,200,300,2000);  
  TH2F *hEdEDeuterons_Reg2 = new TH2F("hEdEDeuterons_Reg2","Deuterons 2nd Reg",200,500,3000,200,300,2000);
  TH2F *hEdEDeuterons_Reg3 = new TH2F("hEdEDeuterons_Reg3","Deuterons 3rd Reg",200,500,3000,200,300,2000);
  TH2F *hEdEDeuterons_Reg4 = new TH2F("hEdEDeuterons_Reg4","Deuterons 4th Reg",200,500,3000,200,300,2000);
  TH2F *hEdEDeuterons_Reg5 = new TH2F("hEdEDeuterons_Reg5","Deuterons 5th Reg",200,500,3000,200,300,2000);

  TH1F *VMomentum1 = new TH1F("VMomentum1","VMomentum1",1000,0,1000);
  TH1F *VMomentum2 = new TH1F("VMomentum2","VMomentum2",1000,0,1000);
  TH1F *VMomentum3 = new TH1F("VMomentum3","VMomentum3",1000,0,1000);
  TH1F *VMomentum4 = new TH1F("VMomentum4","VMomentum4",1000,0,1000);
  TH1F *VMomentum5 = new TH1F("VMomentum5","VMomentum5",1000,0,1000);

  TH1F *MissingMomentum1 = new TH1F("MissingMomentum1","MissingMomentum1",300,0,300);
  TH1F *MissingMomentum2 = new TH1F("MissingMomentum2","MissingMomentum2",300,0,300);
  TH1F *MissingMomentum3 = new TH1F("MissingMomentum3","MissingMomentum3",300,0,300);
  TH1F *MissingMomentum4 = new TH1F("MissingMomentum4","MissingMomentum4",300,0,300);
  TH1F *MissingMomentum5 = new TH1F("MissingMomentum5","MissingMomentum5",300,0,300);
  
  TH1F *MissingMomentumAll = new TH1F("MissingMomentumAll","MissingMomentumAll",300,0,300);
  TH1F *MissingMomentum1Cut = new TH1F("MissingMomentum1Cut","MissingMomentum1Cut",300,0,300);
  TH1F *MissingMomentum2Cut = new TH1F("MissingMomentum2Cut","MissingMomentum2Cut",300,0,300);
  TH1F *MissingMomentum3Cut = new TH1F("MissingMomentum3Cut","MissingMomentum3Cut",300,0,300);
  TH1F *MissingMomentum4Cut = new TH1F("MissingMomentum4Cut","MissingMomentum4Cut",300,0,300);
  TH1F *MissingMomentum5Cut = new TH1F("MissingMomentum5Cut","MissingMomentum5Cut",300,0,300);

  TH1F *hDLt3 = new TH1F("hDLt3","hDLt3",140,760,900);
  TH2F *hDLt3_BBmomentum = new TH2F("hDLt3_BBmomentum","hDLt3_BBmomentum",140,760,900,800,200,1000);

  TH2F *hHRSLmomentum_BBmomentum = new TH2F("hHRSLmomentum_BBmomentum","hHRSLmomentum_BBmomentum",500,2200,2400,500,200,1000);

  
  TH1F *hDLt3Deuterons = new TH1F("hDLt3Deuterons","hDLt3Deuterons",140,760,900);
  TH2F *hDLt3_BBmomentumDeuterons = new TH2F("hDLt3_BBmomentumDeuterons","hDLt3_BBmomentumDeuterons",140,760,900,800,200,1000);
  
  TH1F *hDLt3Protons = new TH1F("hDLt3Protons","hDLt3Protons",140,760,900);
  TH2F *hDLt3_BBmomentumProtons = new TH2F("hDLt3_BBmomentumProtons","hDLt3_BBmomentumProtons",140,760,900,800,200,1000);

  int Deuteron_Helicity_Plus[5];  
  int Deuteron_Helicity_Minus[5]; 
  int Deuteron_Helicity_Zero[5];
  double Deuteron_Asymmetry[5];
  double Deuteron_AsymmetryError[5];
  
  for (int i = 0; i<5; i++){
    Deuteron_Helicity_Plus[i]=0;  
    Deuteron_Helicity_Minus[i]=0; 
    Deuteron_Helicity_Zero[i]=0;
    
    Deuteron_Asymmetry[i] = 0.0;
    Deuteron_AsymmetryError[i] = 0.0;
  }
  
  
  int MM_Deuteron_Helicity_Plus[5];  
  int MM_Deuteron_Helicity_Minus[5]; 
  int MM_Deuteron_Helicity_Zero[5];
  double MM_Deuteron_Asymmetry[5];
  double MM_Deuteron_AsymmetryError[5];
  
  for (int i = 0; i<5; i++){
    MM_Deuteron_Helicity_Plus[i]=0;  
    MM_Deuteron_Helicity_Minus[i]=0; 
    MM_Deuteron_Helicity_Zero[i]=0;
    
    MM_Deuteron_Asymmetry[i] = 0.0;
    MM_Deuteron_AsymmetryError[i] = 0.0;
  }
  
  



  for (int i=0; i<24; i++)
  { 
    
    TString s6 = "hTDCDiffMean_EPaddle";
    s6 +=i;
    cout<<"Name: "<<s6<<endl;
    
    hTDCDiffMean_EPaddle[i] = new TH1F(s6.Data(),s6.Data(), 200,-30,30);
    
    
    TString s8 = "hEdECut_Paddle";
    s8 += i;
    cout<<"Name: "<<s8<<endl;
    
    hEdECut_Paddle[i] = new TH2F(s8.Data(),s8.Data(), 200,500,3000,200,300,2000);
    
  }     


  TH1F *hEDTM = new TH1F("hEDTM","hEDTM", 10,0,9); 
    
  cout<<"*******"<<endl;
  
  
  // First we need to analyze first 50k events tio determine the mean value
  // of time difference
  for (int i=0; i<50000; i++)
  { 
     t1-> GetEntry(i);
     if ((i%1000==0) && (i>0)) cout<<i<<endl;
     
     for (int BAR = 0; BAR<24; BAR++)
     {  
       if ((fabs(BB_tp_e_LT[BAR])<10000) && (fabs(BB_tp_e_RT[BAR])<10000) && (fabs(BB_tp_e_LT[BAR]-
       BB_tp_e_RT[BAR])<20) && ((Ndata_DL_edtmbb)<1))
       {
       
         hTDCDiffMean_EPaddle[BAR]->Fill(BB_tp_e_LT[BAR]-BB_tp_e_RT[BAR]);
         
       }
    }
  }
  
  double TDCMean_EPaddle[24];
  
  for (int BAR=0; BAR<24; BAR++) 
  {
    TDCMean_EPaddle[BAR] = hTDCDiffMean_EPaddle[BAR]->GetMean(); 
    cout<<"--> Mean TDC Diff value for paddle "<<BAR<<" is: "<<TDCMean_EPaddle[BAR]<<endl;
  
  }

  
  
  // Now..... let's rock!
  
  
  // num
  for (int i=0; i<200000; i++)
  { 
     t1-> GetEntry(i);
     if ((i%1000==0) && (i>0)) cout<<i<<endl;
    
     // first some cuts
     if (Ndata_DL_edtmbb!=0  )
     {
       cout<<" EDTM event -- Skipped!"<<endl;
       continue; 
     }
     
     if ( fabs(Ndata_DL_t1-1.0)>1 || fabs(Ndata_DL_t3-1.0)>1 || fabs(VertexTime_tr_n-1.0)>1.0 )
     {
       // cout<<" EDTM event -- Skipped!"<<endl;
       continue; 
     }
     
              
     for (int BAR=0; BAR<24; BAR++)
     { 
      
       if (fabs(DL_t1[0]-800)>20) continue;

       if (BB_tp_e_LA[BAR]>300 && BB_tp_de_LA[BAR]>600 && BB_tp_e_RA[BAR]>300 && BB_tp_de_RA[BAR]>600 
       &&(BAR>=4 && BAR<=17)&& fabs(BB_tp_e_LT[BAR]-BB_tp_e_RT[BAR]-TDCMean_EPaddle[BAR])<2 ){
         
            for (int i = 0; i<Ndata_DL_t3; i++){
              hDLt3->Fill(DL_t3[i]);
              for(int j = 0; j<((int)VertexTime_tr_n); j++) hDLt3_BBmomentum->Fill(DL_t3[i],VertexTime_tr_momentum[j]); 
              
            }  
            for(int j = 0; j<((int)VertexTime_tr_n); j++) 
              hHRSLmomentum_BBmomentum->Fill(1000.0*L_gold_p,VertexTime_tr_momentum[j]);
            
       }
         
       if (BB_tp_e_LA[BAR]>300 && BB_tp_de_LA[BAR]>600 && BB_tp_e_RA[BAR]>300 && BB_tp_de_RA[BAR]>600 
        && fabs(BB_tp_e_LT[BAR]-BB_tp_e_RT[BAR]-TDCMean_EPaddle[BAR])<2 
        && (VertexTime_tr_momentum[0] > (-0.015368*1000.0*L_gold_p*1000.0*L_gold_p + 66.2186*1000.0*L_gold_p-70350.0)) 
        && (VertexTime_tr_momentum[0] > 400.0 + 450*(exp(-(DL_t3[0]-810)/16.4913)))){
     
       
         hEdECut_Paddle[BAR]->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
         
         if (BAR>=4 && BAR<=17) hEdECut_PaddleSum->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,
                                                        (BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
         
          

         
         //---------------------------------------------------------------------------------
         //
         //  Deuterons
         //
         //---------------------------------------------------------------------------------
         
         if((BAR>=4 && BAR<=17)&& ((BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2 > 
             1439.0*(exp(-((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2)/1033.08))+713.116 )&& 
             ((BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2 < 
             1439.0*(exp(-((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2)/1033.08))+713.116+300.0 )){
               
           for (int i = 0; i<Ndata_DL_t3; i++){
             hDLt3Deuterons->Fill(DL_t3[i]);
             for(int j = 0; j<((int)VertexTime_tr_n); j++) 
                hDLt3_BBmomentumDeuterons->Fill(DL_t3[i],VertexTime_tr_momentum[i]); 
           } 
           

             
           if((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2>500 && (BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2<1000 ){
           
              hEdEDeuterons_Reg1->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);

              if (g0hel_L_helicity<0) Deuteron_Helicity_Minus[0]+=1; 
              else if (g0hel_L_helicity>0) Deuteron_Helicity_Plus[0]+=1; 
              else Deuteron_Helicity_Zero[0]+=1; 

              for (int i = 0; i<((int)VertexTime_tr_n); i++) VMomentum1->Fill(VertexTime_tr_momentum[i]);
	          for (int i = 0; i<((int)VertexTime_tr_n); i++){
		         double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		         2809.4 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		         1875*1875.0), 2.0) -pow(938.27,2.0);
                 if (missing_momentumsq >0) MissingMomentum1->Fill(sqrt(missing_momentumsq));
                 else MissingMomentum1->Fill(-1234);
              }
           }
           if((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2>=1000 && (BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2<1500 ){ 
              hEdEDeuterons_Reg2->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
              if (g0hel_L_helicity<0) Deuteron_Helicity_Minus[1]+=1; 
              else if (g0hel_L_helicity>0) Deuteron_Helicity_Plus[1]+=1; 
              else Deuteron_Helicity_Zero[1]+=1; 

              for (int i = 0; i<((int)VertexTime_tr_n); i++) VMomentum2->Fill(VertexTime_tr_momentum[i]);

      	      for (int i = 0; i<((int)VertexTime_tr_n); i++){
		        double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		        2803.5 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		        1875*1875.0), 2.0) -pow(938.27,2.0);
                if (missing_momentumsq >0) MissingMomentum2->Fill(sqrt(missing_momentumsq));
                else MissingMomentum2->Fill(-1234);
              }

           }

           if((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2>=1500 && (BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2<2000 ){ 
              hEdEDeuterons_Reg3->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
              if (g0hel_L_helicity<0) Deuteron_Helicity_Minus[2]+=1; 
              else if (g0hel_L_helicity>0) Deuteron_Helicity_Plus[2]+=1; 
              else Deuteron_Helicity_Zero[2]+=1; 
         
              for (int i = 0; i<((int)VertexTime_tr_n); i++) VMomentum3->Fill(VertexTime_tr_momentum[i]);
	     
	          for (int i = 0; i<((int)VertexTime_tr_n); i++){
		        double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		        2803.5 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		        1875*1875.0), 2.0) -pow(938.27,2.0);
                if (missing_momentumsq >0) MissingMomentum3->Fill(sqrt(missing_momentumsq));
                else MissingMomentum3->Fill(-1234);
              }


           }

           if((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2>=2000 && (BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2<2500 ){ 
              hEdEDeuterons_Reg4->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
              if (g0hel_L_helicity<0) Deuteron_Helicity_Minus[3]+=1; 
              else if (g0hel_L_helicity>0) Deuteron_Helicity_Plus[3]+=1; 
              else Deuteron_Helicity_Zero[3]+=1; 

              for (int i = 0; i<((int)VertexTime_tr_n); i++) VMomentum4->Fill(VertexTime_tr_momentum[i]);

	          for (int i = 0; i<((int)VertexTime_tr_n); i++){
		         double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		         2803.5 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		         1875*1875.0), 2.0) -pow(938.27,2.0);
                if (missing_momentumsq >0) MissingMomentum4->Fill(sqrt(missing_momentumsq));
                else MissingMomentum4->Fill(-1234);
              }


           }

           if((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2>=2500){
              hEdEDeuterons_Reg5->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,(BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
              if (g0hel_L_helicity<0) Deuteron_Helicity_Minus[4]+=1; 
              else if (g0hel_L_helicity>0) Deuteron_Helicity_Plus[4]+=1; 
              else Deuteron_Helicity_Zero[4]+=1; 

              for (int i = 0; i<((int)VertexTime_tr_n); i++) VMomentum5->Fill(VertexTime_tr_momentum[i]);

	          for (int i = 0; i<((int)VertexTime_tr_n); i++){
		        double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		        2803.5 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		        1875*1875.0), 2.0) -pow(938.27,2.0);
                if (missing_momentumsq >0) MissingMomentum5->Fill(sqrt(missing_momentumsq));
                else MissingMomentum5->Fill(-1234);
              }

	       }
	       
	       //***************************************************************
	       //
	       //  Deuteron - Missing momentum separation
	       //
	       //***************************************************************
	       
	       
	       for (int i = 0; i<((int)VertexTime_tr_n); i++){
		      double missing_momentumsq = pow(BeamEnergy - 1000.0*L_gold_p + 
		        2809.4 - sqrt(VertexTime_tr_momentum[i]*VertexTime_tr_momentum[i] + 
		        1875*1875.0), 2.0) -pow(938.27,2.0);
              if (missing_momentumsq <0) MissingMomentumAll->Fill(-1234);
              else {
                double missing_momentum = sqrt(missing_momentumsq);  
                MissingMomentumAll->Fill(missing_momentum);
                
                if (missing_momentum>0 && missing_momentum<50.0){
                  MissingMomentum1Cut->Fill(missing_momentum);
                  if (g0hel_L_helicity<0) MM_Deuteron_Helicity_Minus[0]+=1; 
                  else if (g0hel_L_helicity>0) MM_Deuteron_Helicity_Plus[0]+=1; 
                  else MM_Deuteron_Helicity_Zero[0]+=1; 
                }
                else if (missing_momentum>=50 && missing_momentum<100.0){
                  MissingMomentum2Cut->Fill(missing_momentum);
                  if (g0hel_L_helicity<0) MM_Deuteron_Helicity_Minus[1]+=1; 
                  else if (g0hel_L_helicity>0) MM_Deuteron_Helicity_Plus[1]+=1; 
                  else MM_Deuteron_Helicity_Zero[1]+=1;
                }
                else if (missing_momentum>=100 && missing_momentum<150.0){
                  MissingMomentum3Cut->Fill(missing_momentum);
                  if (g0hel_L_helicity<0) MM_Deuteron_Helicity_Minus[2]+=1; 
                  else if (g0hel_L_helicity>0) MM_Deuteron_Helicity_Plus[2]+=1; 
                  else MM_Deuteron_Helicity_Zero[2]+=1;                  
                }
                else if (missing_momentum>=150 && missing_momentum<200.0){
                  MissingMomentum4Cut->Fill(missing_momentum);
                  if (g0hel_L_helicity<0) MM_Deuteron_Helicity_Minus[3]+=1; 
                  else if (g0hel_L_helicity>0) MM_Deuteron_Helicity_Plus[3]+=1; 
                  else MM_Deuteron_Helicity_Zero[3]+=1;                  
                  
                }
                else if (missing_momentum>=200 && missing_momentum<300.0){
                  MissingMomentum5Cut->Fill(missing_momentum);
                  if (g0hel_L_helicity<0) MM_Deuteron_Helicity_Minus[4]+=1; 
                  else if (g0hel_L_helicity>0) MM_Deuteron_Helicity_Plus[4]+=1; 
                  else MM_Deuteron_Helicity_Zero[4]+=1;             
                }
                   
                
              }

           }
             

         }  

       }
       else if (BB_tp_e_LA[BAR]>300 && BB_tp_de_LA[BAR]>600 && BB_tp_e_RA[BAR]>300 && BB_tp_de_RA[BAR]>600 
       && fabs(BB_tp_e_LT[BAR]-BB_tp_e_RT[BAR]-TDCMean_EPaddle[BAR])<2 &&(VertexTime_tr_momentum[0] <
        (-0.015368*1000.0*L_gold_p*1000.0*L_gold_p + 66.2186*1000.0*L_gold_p-70350.0)) && 
        (VertexTime_tr_momentum[0] < 400.0 + 450*(exp(-(DL_t3[0]-810)/16.4913))) ){
       
         if (BAR>=4 && BAR<=17) hEdECut_PaddleSumProton->Fill((BB_tp_e_LA[BAR]+BB_tp_e_RA[BAR])/2,
                                                        (BB_tp_de_LA[BAR]+BB_tp_de_RA[BAR])/2);
       }
     } 
  }


  TF1 *f1 = new TF1("f1","800*(1-exp(-x/1500))+165",300,2000);
  f1->SetLineColor(kBlue);
  f1->SetLineWidth(2);
  
  TF1 *f2 = new TF1("f2","1549.7*(exp(-x/696.921))+662.111",300,2000);
  f2->SetLineColor(kBlue);
  f2->SetLineWidth(2);

  TF1 *f3 = new TF1("f3","1439.0*(exp(-x/1033.08))+713.116",500,3000);
  f3->SetLineColor(kGreen);
  f3->SetLineWidth(2);
  f3->Draw("same");

  TF1 *f4 = new TF1("f4","1439.0*(exp(-x/1033.08))+713.116+300.0",500,3000);
  f4->SetLineColor(kGreen);
  f4->SetLineWidth(2);
  f4->Draw("same"); 
   
  
 
  TCanvas *c1 = new TCanvas("c1","c1",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c1->Divide(4,6,0.001,0.001);
  for (int BAR = 0; BAR<24; BAR++)
  {
    c1->cd(BAR+1);
    hEdECut_Paddle[BAR]->Draw();
    f1->Draw("same");
    f2->Draw("same");
    f3->Draw("same");
    f4->Draw("same");
  }

  TCanvas *c2 = new TCanvas("c2","c2",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c2->Divide(1,1,0.001,0.001);
  c2->cd(1);
  hEdECut_PaddleSum->Draw();
  f1->Draw("same");
  f2->Draw("same");
  f3->Draw("same");
  f4->Draw("same");

  hEdEDeuterons_Reg1->SetMarkerColor(kOrange);
  hEdEDeuterons_Reg1->SetMarkerStyle(1);
  hEdEDeuterons_Reg1->Draw("same");

  hEdEDeuterons_Reg2->SetMarkerColor(kRed);
  hEdEDeuterons_Reg2->SetMarkerStyle(1);
  hEdEDeuterons_Reg2->Draw("same");

  hEdEDeuterons_Reg3->SetMarkerColor(kMagenta);
  hEdEDeuterons_Reg3->SetMarkerStyle(1);
  hEdEDeuterons_Reg3->Draw("same");

  hEdEDeuterons_Reg4->SetMarkerColor(kViolet);
  hEdEDeuterons_Reg4->SetMarkerStyle(1);
  hEdEDeuterons_Reg4->Draw("same");

  hEdEDeuterons_Reg5->SetMarkerColor(kCyan);
  hEdEDeuterons_Reg5->SetMarkerStyle(1);
  hEdEDeuterons_Reg5->Draw("same");
  
  
  
  TCanvas *c2a = new TCanvas("c2a","c2a",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c2a->Divide(1,1,0.001,0.001);
  c2a->cd(1);
  hEdECut_PaddleSumProton->Draw();
  f1->Draw("same");
  f2->Draw("same");
  f3->Draw("same");
  f4->Draw("same");
 

  
  TCanvas *c3 = new TCanvas("c3","c3",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c3->Divide(4,6,0.001,0.001);
  for (int BAR = 0; BAR<24; BAR++)
  {
    c3->cd(BAR+1);
    gStyle->SetPalette(1);
    hEdECut_Paddle[BAR]->Draw("colz");
    
  }

  TCanvas *c4 = new TCanvas("c4","c4",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c4->Divide(2,3,0.001,0.001);
  c4->cd(1);
  VMomentum1->SetLineColor(kOrange);
  VMomentum1->Draw();
  c4->cd(2);
  VMomentum2->SetLineColor(kRed);
  VMomentum2->Draw();
  c4->cd(3);
  VMomentum3->SetLineColor(kMagenta);
  VMomentum3->Draw();
  c4->cd(4);
  VMomentum4->SetLineColor(kViolet);
  VMomentum4->Draw();
  c4->cd(5);
  VMomentum5->SetLineColor(kCyan);
  VMomentum5->Draw();


  TCanvas *c5 = new TCanvas("c5","c5",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c5->Divide(2,3,0.001,0.001);
  c5->cd(1);
  MissingMomentum1->SetLineColor(kOrange);
  MissingMomentum1->Draw();
  c5->cd(2);
  MissingMomentum2->SetLineColor(kRed);
  MissingMomentum2->Draw();
  c5->cd(3);
  MissingMomentum3->SetLineColor(kMagenta);
  MissingMomentum3->Draw();
  c5->cd(4);
  MissingMomentum4->SetLineColor(kViolet);
  MissingMomentum4->Draw();
  c5->cd(5);
  MissingMomentum5->SetLineColor(kCyan);
  MissingMomentum5->Draw();
  
  c5->cd(6);
  MissingMomentumAll->SetLineColor(kBlack);
  MissingMomentumAll->Draw();
  
  TCanvas *c6 = new TCanvas("c6","c6",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c6->Divide(2,2,0.001,0.001);
  c6->cd(1);
  hDLt3->SetLineColor(kBlue);
  hDLt3->Draw();
  hDLt3Deuterons->SetLineColor(kRed);
  hDLt3Deuterons->Draw("same");
  hDLt3Protons->SetLineColor(kGreen);
  hDLt3Protons->Draw("same");
  c6->cd(2);
  gStyle->SetPalette(1);
  hDLt3_BBmomentum->Draw("colz");
 
 
  TF1 *f6 = new TF1("f6","450*(exp(-(x-810.0)/16.4913))+400", 810, 880);
  f6->SetLineColor(kRed);
  f6->SetLineWidth(2);
  f6->Draw("same"); 
 
  c6->cd(3);
  gStyle->SetPalette(1);
  hHRSLmomentum_BBmomentum->Draw("colz");
   
  TF1 *f7 = new TF1("f7","-0.015368*x*x + 66.2186*x - 70350",2200, 2380);
  f7->SetLineColor(kRed);
  f7->SetLineWidth(2);
  f7->Draw("same"); 
 
  c6->cd(4);
  gStyle->SetPalette(1);
  hDLt3_BBmomentumDeuterons->Draw("colz");



  for (int i =0; i<5; i++)
  {
    cout<<"------- Deuteron Results for region: "<<i<< " ----------------"<<endl;
    cout<<"Helicity + : "<< Deuteron_Helicity_Plus[i]<<endl;
    cout<<"Helicity - : "<< Deuteron_Helicity_Minus[i]<<endl;  
    cout<<"Helicity 0 : "<< Deuteron_Helicity_Zero[i]<<endl;
    cout<<"Good deuterons : "<<Deuteron_Helicity_Plus[i]+Deuteron_Helicity_Minus[i]<<endl; 
    Deuteron_Asymmetry[i] =( 1.0*Deuteron_Helicity_Plus[i]-Deuteron_Helicity_Minus[i])/(1.0*Deuteron_Helicity_Plus[i]+Deuteron_Helicity_Minus[i]);
    Deuteron_AsymmetryError[i] = 1.0/sqrt(1.0*Deuteron_Helicity_Plus[i]+1.0*Deuteron_Helicity_Minus[i]);
    cout<<"Deuteron Asymmetry : "<<Deuteron_Asymmetry[i]<<endl;
    cout<<"Deuteron Asymmetry Error: "<<Deuteron_AsymmetryError[i]<<endl;
    cout<<"-----------------------------------------------------"<<endl;
  }
 
  
  const double DeuteronRegionNumbers[5]= {1.0,2.0,3.0,4.0,5.0};
  const double DeuteronXerror[5]= {0,0,0,0,0};
  
  
  
   
  
  TCanvas *c7 = new TCanvas("c7","c7",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c7->Divide(1,1,0.001,0.001);
  c7->cd(1);
  
  TGraphErrors *gr1 = new TGraphErrors(5, DeuteronRegionNumbers, Deuteron_Asymmetry, DeuteronXerror, Deuteron_AsymmetryError );
  gr1 ->SetMarkerColor(kRed);
  gr1->SetMarkerStyle(25);
  gr1->Draw("AP");
  
  TLine *lin1 = new TLine(1.0,0.0,5.0,0.0);
  lin1->SetLineColor(kGreen);
  lin1->SetLineWidth(2);
  lin1->Draw("same");
  
  
  TCanvas *c8 = new TCanvas("c8","c8",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c8->Divide(1,1,0.001,0.001);
  c8->cd(1);
  MissingMomentumAll->SetLineColor(kBlack);
  MissingMomentumAll->Draw();
  
  MissingMomentum1Cut->SetLineColor(kRed);
  MissingMomentum1Cut->Draw("same");
  
  MissingMomentum2Cut->SetLineColor(kOrange);
  MissingMomentum2Cut->Draw("same");
  
  MissingMomentum3Cut->SetLineColor(kYellow);
  MissingMomentum3Cut->Draw("same");
  
  MissingMomentum4Cut->SetLineColor(kGreen);
  MissingMomentum4Cut->Draw("same");
  
  MissingMomentum5Cut->SetLineColor(kBlue);
  MissingMomentum5Cut->Draw("same");
  
  
  
  
  
  for (int i =0; i<5; i++)
  {
    cout<<"-------Missing Momentum Deuteron Results for region: "<<i<< " ----------"<<endl;
    cout<<"Helicity + : "<< MM_Deuteron_Helicity_Plus[i]<<endl;
    cout<<"Helicity - : "<< MM_Deuteron_Helicity_Minus[i]<<endl;  
    cout<<"Helicity 0 : "<< MM_Deuteron_Helicity_Zero[i]<<endl;
    cout<<"Good deuterons : "<<MM_Deuteron_Helicity_Plus[i]+MM_Deuteron_Helicity_Minus[i]<<endl; 
    MM_Deuteron_Asymmetry[i] =( 1.0*MM_Deuteron_Helicity_Plus[i]-MM_Deuteron_Helicity_Minus[i])/(1.0*MM_Deuteron_Helicity_Plus[i]+MM_Deuteron_Helicity_Minus[i]);
    MM_Deuteron_AsymmetryError[i] = 1.0/sqrt(1.0*MM_Deuteron_Helicity_Plus[i]+1.0*MM_Deuteron_Helicity_Minus[i]);
    cout<<"Deuteron Asymmetry : "<<MM_Deuteron_Asymmetry[i]<<endl;
    cout<<"Deuteron Asymmetry Error: "<<MM_Deuteron_AsymmetryError[i]<<endl;
    cout<<"------------------------------------------------------------------------"<<endl;
  }
 
  
  const double MM_DeuteronRegionNumbers[5]= {MissingMomentum1Cut->GetMean(),
  											 MissingMomentum2Cut->GetMean(),
  											 MissingMomentum3Cut->GetMean(),
  											 MissingMomentum4Cut->GetMean(),
  											 MissingMomentum5Cut->GetMean()};
  											 
  const double MM_DeuteronXerror[5]= {0,0,0,0,0};
  
  
  
   
  
  TCanvas *c9 = new TCanvas("c9","c9",CANVAS_SIZE_X,CANVAS_SIZE_Y);
  c9->Divide(1,1,0.001,0.001);
  c9->cd(1);
  
  TGraphErrors *gr2 = new TGraphErrors(5, MM_DeuteronRegionNumbers, MM_Deuteron_Asymmetry, MM_DeuteronXerror, MM_Deuteron_AsymmetryError );
  gr2 ->SetMarkerColor(kViolet);
  gr2->SetMarkerStyle(27);
  gr2->Draw("AP");
  
  TLine *lin2 = new TLine(0,0.0,300.0,0.0);
  lin2->SetLineColor(kGreen);
  lin2->SetLineWidth(2);
  lin2->Draw("same");
 
  
  
 
  
  
  
  TString name_c1; 
  TString name_c2;
  TString name_c3;
  TString name_c4;
  TString name_c5;
  TString name_c6;
  TString name_c7;
  TString name_c8;
  TString name_c9;
  
  name_c1.Form("dEoverE_Run%d.png",runnumber);  
  name_c2.Form("dEoverE_All_Run%d.png",runnumber);
  name_c3.Form("dEoverE_color_Run%d.png",runnumber);
  name_c4.Form("Momentum_Run%d.png",runnumber);
  name_c5.Form("MissingMomentum_Run%d.png",runnumber);
  name_c6.Form("Kinematics_Run%d.png",runnumber);
  name_c7.Form("Asymmetries_Run%d.png",runnumber);
  name_c8.Form("MissingMomentumCut_Run%d.png",runnumber);
  name_c9.Form("MM_Asymmetries_Run%d.png",runnumber);
  
  c1->Print(name_c1.Data());  
  c2->Print(name_c2.Data());
  c3->Print(name_c3.Data());
  c4->Print(name_c4.Data()); 
  c5->Print(name_c5.Data()); 
  c6->Print(name_c6.Data());
  c7->Print(name_c7.Data());
  c8->Print(name_c8.Data());
  c9->Print(name_c9.Data());
  
  cout<<"QED!!"<<endl;
  
}


void dEoverEanalysis4()
{
  HallA_style();
  racunaj();  
}
